// JGreet (Very tentative name)  plugin for xdm with xdm-extgreet patch
// found at http://tr.ml.org/~tom/software/xdm
// This code by Jarrod Johnson, an attempt to learn the best GUI toolkit, GTK

#include "main.h"
#include "utils.h"
#include "out.h"

#define add(x, y) gtk_container_add(GTK_CONTAINER(x), y); \
                  gtk_widget_show(y);

#define tadd(x, y, a, b, c, d) gtk_table_attach_defaults(GTK_TABLE(x), y, a, b, c, d); \
                               gtk_widget_show(y);

GtkWidget *window;
GtkWidget *frame;
GtkWidget *table;

GtkWidget *userentry;
GtkWidget *userlabel;
GtkWidget *passentry;
GtkWidget *passlabel;
GtkWidget *status;
GtkWidget *login;
GtkWidget *bgbutton;

void login_failed(int ignored)
{
   gtk_entry_set_text (GTK_ENTRY (passentry), "");
   gtk_label_set (GTK_LABEL (status), "Login failed.");

   signal (SIGUSR1, login_failed);
}


void check_cred(char *user, char *pass)
{
   writestring (3, user);
   writestring (3, pass);
   writeuc (3,0);
}

void cycle_bg(GtkWidget *widget, void *ignored)
{
   char filename[FILENAME_MAX];
   randfilename(FILE_LIST, filename);
   set_bg(filename);
   return;
}

void authenticate (GtkWidget * widget, void *ignored)
{
   char *user;
   char *pass;
   user = gtk_entry_get_text (GTK_ENTRY (userentry));
   pass = gtk_entry_get_text (GTK_ENTRY (passentry));

   if (GTK_WIDGET_HAS_FOCUS (userentry)) {
      gtk_widget_grab_focus (passentry);
      return;
   }

   gtk_label_set (GTK_LABEL (status), "Validating...");
   check_cred (user, pass);
}

int main(int argc, char** argv)
{
   gtk_init(&argc, &argv);
   GdkCursor *cursor;
   table=gtk_table_new(4,2,0);
   window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
   frame = gtk_frame_new (GREETING);

   cycle_bg(NULL, NULL);
   userlabel = gtk_label_new ("Username");
   userentry = gtk_entry_new ();
   passlabel = gtk_label_new ("Password");
   passentry = gtk_entry_new ();
   gtk_entry_set_visibility (GTK_ENTRY (passentry), 0);

   status = gtk_label_new (" ");

   login = gtk_button_new_with_label ("Login");
   bgbutton = gtk_button_new_with_label("Cycle background");

   GTK_WIDGET_SET_FLAGS (login, GTK_CAN_DEFAULT);
   gtk_signal_connect ((GtkObject *) login, "clicked",
                       (GtkSignalFunc) authenticate, NULL);
   gtk_signal_connect ((GtkObject *) userentry, "activate",
			(GtkSignalFunc) authenticate, NULL);
   gtk_signal_connect ((GtkObject *) passentry, "activate",
			(GtkSignalFunc) authenticate, NULL);
			
   gtk_signal_connect ((GtkObject *) bgbutton, "clicked",
                       (GtkSignalFunc) cycle_bg, NULL);
   gtk_container_border_width (GTK_CONTAINER (frame), 5);
   gtk_container_border_width (GTK_CONTAINER (table), 5);
   cursor = gdk_cursor_new (GDK_CROSSHAIR);

   tadd(table, userlabel, 0, 1, 0, 1);
   tadd(table, userentry, 1, 2, 0, 1);
   tadd(table, passlabel, 0, 1, 1, 2);
   tadd(table, passentry, 1, 2, 1, 2);
   tadd(table, status, 0, 2, 2, 3);
   tadd(table, login, 1, 2, 3, 4);
   tadd(table, bgbutton, 0, 1, 3, 4);

   add(frame, table);
   add (window, frame);

   gtk_widget_set_uposition (window, X, Y);
   gtk_widget_show (window);

   gtk_widget_grab_default (login);
   gtk_widget_grab_focus (userentry);
   
   signal (SIGUSR1, login_failed);

   gdk_window_set_cursor (window->window, cursor);
   XWarpPointer (GDK_WINDOW_XDISPLAY (window->window), None, 
                 GDK_WINDOW_XWINDOW (window->window),
                 0, 0, 0, 0, 1, 1);

   gtk_main();
}

