// strings.cpp -- collection of functions for manipulating c-strings
// Jarrod Johnson (jbjohns4@eos.ncsu.edu)  ID: 244-55-8482
// CSC210 Section 005, Instructor: Matt Stallman

int length(const char s[])
// Returns length of passed c-string, not counting \0 as a significant character
{
   int count = 0;
   while (s[count] != '\0') 
      count++;
   return count;
} 
	

void reverse(char s[])
// Takes passed C-String and reverses it's order
{
   char temp;
   int end;
   int begin = 0;

   end = length(s) - 1;
   while ( begin < end ) {
      temp = s[begin];
      s[begin++] = s[end];
      s[end--] = temp;
   } 
}

void insert(char s1[], const char s2[], int n)
// inserts the string s2 into s1 immediately following the nth character
// will place it at end if n is greater than length of s1
{
   int first_count = 0;
   int second_count = 0;
   int offset = 0;

   if (n >= length(s1)) {
      first_count = length(s1);
      while (s2[second_count] != '\0') 
         s1[first_count++] = s2[second_count++];
      s1[first_count] = '\0';
   } else {
      offset = length(s2);
      s1[length(s1)+offset] = '\0';
      for ( int i = (length(s1) - 1) ; i >= n ; i-- )
         s1[i + offset] = s1[i];
      for ( int j = 0 ; s2[j] != '\0' ; j++ )
         s1[n+j] = s2[j];
   }    
}      

bool search(const char s1[], const char s2[])
// Searches for string s2 in s1, evaluates to true if found, false otherwise
{
   int first_count = 0;
   int second_count = 0;

   if (length(s2) == 0)
      return true;
   while (first_count < length(s1)) {
      if (s1[first_count] == s2[0]) {
         while ((s1[first_count + second_count] == s2[second_count]) && (second_count != length(s2))) 
            second_count++;
         if (s2[second_count] == '\0')   
            return true;
         second_count = 0;
      }
      first_count++;
   }
   return false;
}
